{$M 16384,0,655360}
{PLT2DXF (c) 1990-1999 by Martin Vogel}
{$A+} {Wortgrenzenausrichtung}
{$B-} {Kurzschluauswertung logischer Ausdrcke}
{$D-} {Debuggerinformationen erzeugen}
{$E-} {Coproz.-Emulation}
{$F-} {Near-Calls erlaubt}
{$G+} {80286-Befehlssatz ausnutzen}
{$I-} {Kein Programmabbruch bei I/O-Fehlern}
{$L-} {Lokale Symbole beim Debuggen nicht verfgbar}
{$N+} {Coprozessor nutzen}
{$O-} {Keine Overlays}
{$P-} {Array-Grenzen offen}
{$Q-} {Kein Test auf Integer-berlauf}
{$R-} {Keine Bereichsberprfung}
{$S-} {Keine Stackberprfung}
{$T-} {Kein Test auf Zeigertypen}
{$V-} {Beliebige Stringlngen}
{$X+} {Erweiterte ("C"-) Syntax}
{$Y-} {Keine Symbolinformationen erzeugen}
{$M 16384,70000,70000}
{
  Dieses Programm ist urheberrechtlich geschtzt.
  Die Copyright-Texte drfen ergnzt, aber nicht berschrieben werden.
  Jede kommerzielle Verwertung des Quelltextes ohne ausdrckliche
  schriftliche Genehmigung ist untersagt.

	Autor:  Dipl.-Ing. Martin Vogel
                Beurhausstrasse 25
		44137 Dortmund

		Tel/Fax 0231-1655294
                martin.vogel@ruhr-uni-bochum.de
                http://homepage.ruhr-uni-bochum.de/martin.vogel

      Sprache:  Borland Pascal 7.0

------------------------------------------------------------------------------
PLT2DXF wandelt HPGL-Plot-Dateien in AutoCAD-DXF-Dateien um.

  0.2
  1990		Die Strichstrken knnen nun nachtrglich
		gendert werden.
  0.3
  13.7.1991	Verschiedene Dateinamen fr Plotdatei und DXF-Datei
		sind mglich.
  0.4
  29.2.92	Vermeidung von Polylinien mit weniger als zwei
		Punkten.
  1.00
  2.3.1992	Entfernung der Stiftauswertung (Geschwindigkeit).
		Header mit Limiten und Zeichnungsgrenzen wird geschrieben.
		Flexiblere Formatauswertung der Eingangsdatei.
		Registrierformular.
		Parametertrenner ' ' und ','.
		Befehlstrenner unntig.
		Irrelevanmte Daten jeder Art werden berlesen,
                bei jedem 'P' wird nachgesehen, ob 'A', 'U' oder 'D'
                folgen, dann wird nach Parametern gesucht.
		Pufferung der Ein- und Ausgabe.

  1.10
  29.6.92	CI-Befehl fr Kreise eingebaut.
		ARC-Befehle werden gesondert aussortiert, da sie drei
		Parameter haben.
		Stift wird am Ende der Datei gehoben.

  1.20
  8.11.92       YT und XT fr Achsenmarkierungen.

  1.21
  22.6.93       Zieldateiname '*' als Batchparameter bernimmt Vorgabe.

  1.22
  22.6.93       Stiftnummer->Layernummer.

  1.23
  25.10.95      Strichstaerke wieder eingebaut.
                Zuerst nur eine Staerke fuer alle Stifte.
  1.24
  20.1.96       Plot Relativ und Absolut als Schalter

  1.25
  30.1.96       Etwas aufgeraeumt.

  1.26
  1.2.96        Layerprefix war immer "P". Jetzt nderbare Konstante.

  1.27
  8.3.96        Neue Paketierung der Sharewareversion

}
{ $DEFINE Shareware} {Registrierformular als Schlubildschirm}
USES DOS,windows,crt,disundas;

{$IFOPT N+}
TYPE REAL=DOUBLE;
{$ENDIF}

TYPE Stiftstatus=(oben,unten);
     Puffertyp=array[1..$8000] of Byte;
     Befehlsname=(unbekannt,PA,PD,PR,PU,CI,SP,XT,YT,SC);


CONST
     version='1.27';
     nl=#13#10;
     Plotterfaktor=40.0; {Normal fr HPGL: 40 Einheiten = 1 mm}

VAR
  PLT,DXF:TEXT;
  PLTName,
  DXFName:Pathstr;
  Stift:Stiftstatus;
  Polylinien,
  Kreise,
  Vertices, {Scheitelpunkte pro Linie}
  n,
  a,b:Longint;
  minx,miny,
  maxx,maxy,
  xstart,ystart,
  tl,ls,
  x,y,r:Real;
  Fertig:Boolean;
  Zeichen:CHAR;
  einbuf,
  ausbuf:^Puffertyp;
  HatParameter:Boolean;
  dir:dirstr;
  name:namestr;
  ext:extstr;
  s:string;
  bin:file;
  Batchmodus:Boolean;
  PlotRelativ:Boolean;

CONST LayerPrefix='P';
CONST Layer:String[6]=Layerprefix+'0';

{Stiftnummer (Word) als String}
Function WS(W:Word):String;
VAR S:String;
BEGIN
  STR(W,S);
  WS:=S;
END;

function befehl(VAR a,b:LONGINT):Befehlsname;
VAR
    s:String;
    valcode:Integer;
const Zeichen:Char='#';
const letzterbefehl:befehlsname=unbekannt;
{Das letzte Zeichen wird gemerkt, falls keine Befehlstrenner vorkommen.}

Procedure Lieszeichen;
BEGIN
  repeat
    Read(plt,zeichen);
    fertig:=eof(plt) or (ioresult<>0);
  until (zeichen>#32) or fertig;
END;

BEGIN
  Fertig:=True;
  Befehl:=unbekannt;
  While (Zeichen<'A')
    and ((zeichen<'0') or (zeichen>'9') or (zeichen='-'))
    and (Zeichen<>',')
    and not eof(plt) do
    LiesZeichen;

  {Weiter mit Parametern?}
  If Zeichen>='A' Then
  Case Zeichen of
  'P': begin
	 LiesZeichen;
	 case Zeichen of
	 'A':LetzterBefehl:=PA;
	 'D':LetzterBefehl:=PD;
	 'U':LetzterBefehl:=PU;
	 'R':LetzterBefehl:=PR;
	 end;
       end;
  'C': begin
	 LiesZeichen;
	 If Zeichen='I' Then LetzterBefehl:=CI;
       end;
  'S': begin
	 LiesZeichen;
	 Case zeichen of
	 'P': LetzterBefehl:=SP;
	 'C': LetzterBefehl:=SC;
	 end;
       end;
  {Die ARC-Befehle haben drei Parameter und werden berlesen:}
  'A': begin
	 repeat
	 LiesZeichen;
	 until eof(plt)
	       or (zeichen<',')
	       or (zeichen=';');
	 LetzterBefehl:=PU;
       END;
  'X': begin
	 LiesZeichen;
	 If Zeichen='T' Then LetzterBefehl:=XT;
       end;
  'Y': begin
	 LiesZeichen;
	 If Zeichen='T' Then LetzterBefehl:=YT;
       end;
  ELSE LetzterBefehl:=unbekannt;
  END; {CASE}

  Befehl:=Letzterbefehl;
  {Jetzt zwei Parameter lesen:}
  s:='';
  LiesZeichen;
  if (Zeichen='-') or ((Zeichen>='0') and (Zeichen<='9'))
  then
    begin
      hatparameter:=true;
      While (Zeichen='-')
	 or ((Zeichen>='0') and (Zeichen<='9')) DO
	BEGIN
	  inc(s[0]);
	  s[length(s)]:=zeichen;
	  LiesZeichen;
	END;
      VAL(s,a,valcode);
      If (Zeichen=',') or (Zeichen=' ') THEN
      BEGIN
	s:='';
	LiesZeichen;
	While (Zeichen='-')
	   or ((Zeichen>='0') and (Zeichen<='9')) DO
	  BEGIN
	    inc(s[0]);
	    s[length(s)]:=zeichen;
	    LiesZeichen;
	  END;
	VAL(s,b,valcode);
      END;
    end {hat parameter}
  else hatparameter:=false;
  FERTIG:=EOF(PLT);
END;

Procedure Registrierformular(version:String);
begin
  Clrscr;
  textcolor(textattr div 16); {Hintergrund}
  write(#12);
  Window(9,1,80,25);
  normvideo;
  Write('             SHAREWARE-REGISTRIERUNG PLT2DXF V',version,
  nl,
  nl,'  Name/Firma',':  ___________________________________________________',
  nl,
  nl,'     Strasse',':  ___________________________________________________',
  nl,
  nl,'     PLZ/Ort',':  ___________________________________________________',
  nl,
  nl,'Bezugsquelle',':  ___________________________________________________',
  nl,
  nl,'Senden Sie diesen Abschnitt bitte ausgefuellt an:',
  nl,
  nl,'           Martin Vogel, Beurhausstr. 25, 44137 Dortmund.',
  nl,
  nl,'  Legen Sie dem Schreiben einen Verrechnungsscheck ueber DM 50,- bei',
  nl,'(Studenten gegen Nachweis DM 30,-) oder ueberweisen Sie den Betrag',
  nl,'auf Konto Nr. 5118404910 bei der Volksbank Hagen eG (BLZ 45060009).',
  nl,
  nl,'  Die neueste Version des Programms wird Ihnen auf Wunsch zugesandt.',
  nl,'Kritik und Spenden sind jederzeit willkommen.');
  Window(1,1,80,25);
  gotoxy(66,25);
  write('[PrintScreen]');
  textcolor(textattr div 16); {Hintergrund}
  write(#12);
  while keypressed do readkey;
  repeat readkey until not keypressed;
  normvideo;
  writeln;
end;

Procedure Stiftheben;
BEGIN
  If Stift=unten THEN
  BEGIN
    if vertices=1
    {NEU in 0.40, weil Polylinien mit einem Punkt verboten sind}
    THEN Write(DXF,'0',nl,'VERTEX',nl,
		   '8',nl,Layer,nl,
		   '10',nl,x+ls:0:3,nl,'20',nl,y:0:3,nl);
    Stift:=oben;
    Write(DXF,'0',nl,'SEQEND',nl);
    INC(Polylinien);
    Write(polylinien:6,^M);
    Fertig :=keypressed and (readkey=#27);
  END;
END; {Stiftheben}


BEGIN
  normvideo;
  clrscr;
  Writeln;
  Writeln('PLT2DXF Version ',version,'Copyright 1990 - 1996 by Martin Vogel':59);
  Writeln;
  Writeln('PLT2DXF konvertiert HPGL-Plotterdateien zu DXF-Zeichnungsaustauschdateien.');
  Writeln;
  Writeln('Format: PLT2DXF Dateiname.PLT Dateiname.DXF Linienbreite');
  Writeln;

  If Paramcount>=1 then PLTName:=Paramstr(1)
  else
    begin
      write('Name der HPGL-Datei [*.PLT]: ');
      readln(PLTNAME);
      if pltname='' then pltname:='*.PLT';
      if (pos('*',pltname)<>0) or (pos('?',pltname)<>0)
      Then PLTName:=dirget(pltname);
      if pltname='' then
      begin
	writeln;
	Writeln('Dann eben nicht. (schade...)');
	halt(1);
      end
      else if pos('.',pltname)=0
	   then pltname:=pltname+'.PLT';
    end;

  fsplit(pltname,dir,name,ext);
  If Paramcount>=2 then DXFName:=Paramstr(2)
  else
    begin
      write('Name der DXF-Datei [',dir,name,'.DXF]: ');
      Readln(DXFName);
    end;
  BatchModus:=DxfName='*';
  if (dxfname='')
  or (dxfname='*') then dxfname:=dir+name+'.DXF';

  If Paramcount>=3 then ls:=ator(Paramstr(3))
  else
    begin
      write('Linienbreite fuer alle Elemente [0]: ');
      Readln(s);
      ls:=ator(s);
    end;

  Writeln;
  Writeln(PLTName,' --> ',DXFName,nl);
  Writeln('Zeichnungslayer ist "',Layerprefix,'n", n ist Stiftnummer.');
  Write(0:6,' Polylinien geschrieben. Abbruch mit <ESC>'#13);

  new(einbuf);
  new(ausbuf);
  ASSIGN(PLT,PLTName);
  settextbuf(plt,einbuf^);
  RESET(PLT);
  if ioresult<>0 then
  begin
    Writeln;
    Writeln('Fehler beim Oeffnen der Plotdatei!');
    Halt(1);
  end;
  ASSIGN(DXF,DXFName);
  settextbuf(dxf,ausbuf^);
  REWRITE(DXF);
  if ioresult<>0 then
  begin
    Writeln;
    Writeln('Fehler beim Anlegen der DXF-Datei!');
    Halt(1);
  end;

  {DXF-HEADER}
  {!!! ACHTUNG !!!
   In die 0000000000-Felder wird am Ende des Programms mit
   BLOCKWRITE die Zeichnungsgre eingetragen. Wegen der direkten
   Positionierung darf NICHTS am Header-Aufbau gendert werden!}
  write(DXF,
      '0',nl,'SECTION',nl,'2',nl,'HEADER',nl,
      '9',nl,'$EXTMIN',nl,'10',nl,'0000000000',nl,'20',nl,'0000000000',nl,
      '9',nl,'$EXTMAX',nl,'10',nl,'0000000000',nl,'20',nl,'0000000000',nl,
      '9',nl,'$LIMMIN',nl,'10',nl,'0000000000',nl,'20',nl,'0000000000',nl,
      '9',nl,'$LIMMAX',nl,'10',nl,'0000000000',nl,'20',nl,'0000000000',nl,
      '0',nl,'ENDSEC',nl);

  write(DXF,'0',nl,'SECTION',nl,'2',nl,'ENTITIES',nl);
  Stift:=Oben;
  Fertig:=FALSE;
  PlotRelativ:=FALSE;
  x:=0;
  y:=0;
  Polylinien:=0;
  Kreise:=0;
  minx:=1e20;
  maxx:=-1e20;
  miny:=1e20;
  maxy:=-1e20;
  tl:=0.5;

  Repeat
    CASE BEFEHL(a,b) of
    PA:
      BEGIN
      PlotRelativ:=FALSE;
      If Hatparameter then
      BEGIN
	x:=a/Plotterfaktor;
	y:=b/Plotterfaktor;
	IF Stift=unten
	THEN
	BEGIN
          if (vertices<3)
          and (y=ystart)
          and (x=xstart)
          then x:=x+ls; {Vermeidung von "Punkten" bei Strichstaerke}
	  Write(DXF,'0',nl,'VERTEX',nl,
		    '8',nl,Layer,nl,
		    '10',nl,x:0:3,nl,'20',nl,y:0:3,nl);
	  inc(vertices);
	  if x<minx then minx:=x;
	  if x>maxx then maxx:=x;
	  if y<miny then miny:=y;
	  if y>maxy then maxy:=y;
	END;
      END;
      END;
    PD:
      BEGIN
      If Stift=oben THEN
      BEGIN
	Stift:=unten;
	Vertices:=1;
	Write(DXF,'0',nl,'POLYLINE',nl,
		  '8',nl,Layer,nl,
		  '66',nl,'1',nl, {Attribute folgen}
		  '40',nl,ls:0:3,nl, {Startdicke}
		  '41',nl,ls:0:3,nl, {Enddicke}
		  '0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x:0:3,nl,'20',nl,y:0:3,nl);
        xstart:=x;
        ystart:=y;
      END;
      If HatParameter Then
      BEGIN
	if x<minx then minx:=x;
	if x>maxx then maxx:=x;
	if y<miny then miny:=y;
	if y>maxy then maxy:=y;
        if plotrelativ
        then begin
	x:=x+a/Plotterfaktor;
	y:=y+b/Plotterfaktor;
        end
        else begin
	x:=a/Plotterfaktor;
	y:=b/Plotterfaktor;
        end;
	if x<minx then minx:=x;
	if x>maxx then maxx:=x;
	if y<miny then miny:=y;
	if y>maxy then maxy:=y;
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x:0:3,nl,'20',nl,y:0:3,nl);
	inc(vertices);
      END;
      END;
    PU:
      BEGIN
      StiftHeben;
      If HatParameter Then
      BEGIN
        if PlotRelativ
        then begin
	x:=x+a/Plotterfaktor;
	y:=y+b/Plotterfaktor;
        end
        else begin
	x:=a/Plotterfaktor;
	y:=b/Plotterfaktor;
        end;
      END;
      END;
    CI:
      BEGIN
	Stiftheben;
	r:=a/Plotterfaktor;
	Write(DXF,'0',nl,'CIRCLE',nl,
		    '8',nl,Layer,nl,
		    '10',nl,x:0:3,nl,'20',nl,y:0:3,nl,'40',nl,r:0:3,nl);
	Stift:=Oben;
	INC(Kreise);
      END;
    PR:
      BEGIN
        PlotRelativ:=TRUE;
        if HatParameter then
        begin
	x:=x+a/Plotterfaktor;
	y:=y+b/Plotterfaktor;
	IF Stift=unten
	THEN
	BEGIN
	  Write(DXF,'0',nl,'VERTEX',nl,
		    '8',nl,Layer,nl,
		    '10',nl,x:0:3,nl,'20',nl,y:0:3,nl);
	  inc(vertices);
	  if x<minx then minx:=x;
	  if x>maxx then maxx:=x;
	  if y<miny then miny:=y;
	  if y>maxy then maxy:=y;
	END;
        end;
      END;
    XT:
      BEGIN
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x:0:3,nl,'20',nl,y-tl:0:3,nl);
	inc(vertices);
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x:0:3,nl,'20',nl,y+tl:0:3,nl);
	inc(vertices);
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x:0:3,nl,'20',nl,y:0:3,nl);
	inc(vertices);
      END;
    YT:
      BEGIN
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x-tl:0:3,nl,'20',nl,y:0:3,nl);
	inc(vertices);
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x+tl:0:3,nl,'20',nl,y:0:3,nl);
	inc(vertices);
	Write(DXF,'0',nl,'VERTEX',nl,
		  '8',nl,Layer,nl,
		  '10',nl,x:0:3,nl,'20',nl,y:0:3,nl);
	inc(vertices);
      END;
    SC:
      BEGIN
	TL:=(b-a)/(200*Plotterfaktor)
      END;
    SP:
      BEGIN
        Layer:=LayerPrefix+WS(a);
      END;
    end; {CASE}

  Until Fertig;
  Stiftheben;
  write(DXF,'0',nl,'ENDSEC',nl,'0',nl,'EOF',nl);

  CLOSE(PLT);
  CLOSE(DXF);

  clreol;
  writeln(polylinien,' Polylinien geschrieben.');
  if kreise>0 then writeln(Kreise,' Kreise geschrieben.');

  {Noch die Zeichnungsgrenzen nachtragen:}
  assign(bin,dxfname);
  reset(bin,1);
  str(minx:10:3,s);seek(bin,39);blockwrite(bin,s[1],10);
  str(miny:10:3,s);seek(bin,55);blockwrite(bin,s[1],10);
  str(maxx:10:3,s);seek(bin,83);blockwrite(bin,s[1],10);
  str(maxy:10:3,s);seek(bin,99);blockwrite(bin,s[1],10);

  {Limiten mit 10 mm Rand:}
  str(minx-10:10:3,s);seek(bin,127);blockwrite(bin,s[1],10);
  str(miny-10:10:3,s);seek(bin,143);blockwrite(bin,s[1],10);
  str(maxx+10:10:3,s);seek(bin,171);blockwrite(bin,s[1],10);
  str(maxy+10:10:3,s);seek(bin,187);blockwrite(bin,s[1],10);

  fsplit(dxfname,dir,name,ext);
  writeln(' ',name,ext,' hat ',filesize(bin),' Byte.');
  close(bin);

  Writeln(nl,
	  'Zeichnungsgrenzen: min X = ',minx:7:3,'  max X = ',maxx:7:3,nl,
	  '                   min Y = ',miny:7:3,'  max Y = ',maxy:7:3,nl);
  IF not BatchModus then
  begin
  Write('Weiter mit beliebigem Tastendruck');
  while keypressed do readkey;
  repeat readkey until not keypressed;
  end;

{$IFDEF ShareWare}
  Registrierformular(version);
{$ENDIF}
  Writeln(#13'Dipl.-Ing. Martin Vogel, Beurhausstr. 25, 44137 Dortmund, Tel/Fax 0231-1655294');
  writeln('http://homepage.ruhr-uni-bochum.de/martin.vogel');
  Writeln;
END.

